/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */


#include <core/core.h>

#include "move_options.h"

MoveOptions::MoveOptions (bool init /* = true */) :
    mOptions (MoveOptions::OptionNum),
    mNotify (MoveOptions::OptionNum)
{
    if (init)
        initOptions ();
}

void
MoveOptions::initOptions ()
{
    unsigned int state;
    CompAction action;

    // initiate_button
    mOptions[MoveOptions::InitiateButton].setName ("initiate_button", CompOption::TypeButton);
    state = CompAction::StateAutoGrab;
    action = CompAction ();
    action.setState (state | CompAction::StateInitButton);
    action.buttonFromString ("<Alt>Button1");
    mOptions[MoveOptions::InitiateButton].value().set (action);
    if (screen) screen->addAction (&mOptions[MoveOptions::InitiateButton].value ().action ());

    // initiate_key
    mOptions[MoveOptions::InitiateKey].setName ("initiate_key", CompOption::TypeKey);
    state = CompAction::StateAutoGrab;
    action = CompAction ();
    action.setState (state | CompAction::StateInitKey);
    action.keyFromString ("<Alt>F7");
    mOptions[MoveOptions::InitiateKey].value().set (action);
    if (screen) screen->addAction (&mOptions[MoveOptions::InitiateKey].value ().action ());

    // opacity
    mOptions[MoveOptions::Opacity].setName ("opacity", CompOption::TypeInt);
    mOptions[MoveOptions::Opacity].rest ().set (1, 100);
    mOptions[MoveOptions::Opacity].value().set((int) 100);

    // key_move_inc
    mOptions[MoveOptions::KeyMoveInc].setName ("key_move_inc", CompOption::TypeInt);
    mOptions[MoveOptions::KeyMoveInc].rest ().set (1, 250);
    mOptions[MoveOptions::KeyMoveInc].value().set((int) 24);

    // constrain_y
    mOptions[MoveOptions::ConstrainY].setName ("constrain_y", CompOption::TypeBool);
    mOptions[MoveOptions::ConstrainY].value().set(true);

    // snapoff_semimaximized
    mOptions[MoveOptions::SnapoffSemimaximized].setName ("snapoff_semimaximized", CompOption::TypeBool);
    mOptions[MoveOptions::SnapoffSemimaximized].value().set(true);

    // snapoff_distance
    mOptions[MoveOptions::SnapoffDistance].setName ("snapoff_distance", CompOption::TypeInt);
    mOptions[MoveOptions::SnapoffDistance].rest ().set (0, 500);
    mOptions[MoveOptions::SnapoffDistance].value().set((int) 100);

    // snapback_semimaximized
    mOptions[MoveOptions::SnapbackSemimaximized].setName ("snapback_semimaximized", CompOption::TypeBool);
    mOptions[MoveOptions::SnapbackSemimaximized].value().set(true);

    // snapback_distance
    mOptions[MoveOptions::SnapbackDistance].setName ("snapback_distance", CompOption::TypeInt);
    mOptions[MoveOptions::SnapbackDistance].rest ().set (0, 250);
    mOptions[MoveOptions::SnapbackDistance].value().set((int) 20);

    // lazy_positioning
    mOptions[MoveOptions::LazyPositioning].setName ("lazy_positioning", CompOption::TypeBool);
    mOptions[MoveOptions::LazyPositioning].value().set(false);

}

MoveOptions::~MoveOptions ()
{
}


CompOption::Vector &
MoveOptions::getOptions ()
{
    return mOptions;
}

bool
MoveOptions::setOption (const CompString &name, CompOption::Value &value)
{
    CompOption   *o;
    unsigned int index;

    o = CompOption::findOption (mOptions, name, &index);

    if (!o)
        return false;

    switch (index)
    {
        case MoveOptions::InitiateButton:
            if (o->set (value))
            {
                if (!mNotify[MoveOptions::InitiateButton].empty ())
                    mNotify[MoveOptions::InitiateButton] (o, MoveOptions::InitiateButton);
                return true;
            }
            break;
        case MoveOptions::InitiateKey:
            if (o->set (value))
            {
                if (!mNotify[MoveOptions::InitiateKey].empty ())
                    mNotify[MoveOptions::InitiateKey] (o, MoveOptions::InitiateKey);
                return true;
            }
            break;
        case MoveOptions::Opacity:
            if (o->set (value))
            {
                if (!mNotify[MoveOptions::Opacity].empty ())
                    mNotify[MoveOptions::Opacity] (o, MoveOptions::Opacity);
                return true;
            }
            break;
        case MoveOptions::KeyMoveInc:
            if (o->set (value))
            {
                if (!mNotify[MoveOptions::KeyMoveInc].empty ())
                    mNotify[MoveOptions::KeyMoveInc] (o, MoveOptions::KeyMoveInc);
                return true;
            }
            break;
        case MoveOptions::ConstrainY:
            if (o->set (value))
            {
                if (!mNotify[MoveOptions::ConstrainY].empty ())
                    mNotify[MoveOptions::ConstrainY] (o, MoveOptions::ConstrainY);
                return true;
            }
            break;
        case MoveOptions::SnapoffSemimaximized:
            if (o->set (value))
            {
                if (!mNotify[MoveOptions::SnapoffSemimaximized].empty ())
                    mNotify[MoveOptions::SnapoffSemimaximized] (o, MoveOptions::SnapoffSemimaximized);
                return true;
            }
            break;
        case MoveOptions::SnapoffDistance:
            if (o->set (value))
            {
                if (!mNotify[MoveOptions::SnapoffDistance].empty ())
                    mNotify[MoveOptions::SnapoffDistance] (o, MoveOptions::SnapoffDistance);
                return true;
            }
            break;
        case MoveOptions::SnapbackSemimaximized:
            if (o->set (value))
            {
                if (!mNotify[MoveOptions::SnapbackSemimaximized].empty ())
                    mNotify[MoveOptions::SnapbackSemimaximized] (o, MoveOptions::SnapbackSemimaximized);
                return true;
            }
            break;
        case MoveOptions::SnapbackDistance:
            if (o->set (value))
            {
                if (!mNotify[MoveOptions::SnapbackDistance].empty ())
                    mNotify[MoveOptions::SnapbackDistance] (o, MoveOptions::SnapbackDistance);
                return true;
            }
            break;
        case MoveOptions::LazyPositioning:
            if (o->set (value))
            {
                if (!mNotify[MoveOptions::LazyPositioning].empty ())
                    mNotify[MoveOptions::LazyPositioning] (o, MoveOptions::LazyPositioning);
                return true;
            }
            break;
        default:
            break;
    }
    return false;

}

