/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _MOVE_OPTIONS_H
#define _MOVE_OPTIONS_H

#include <core/core.h>

class MoveOptions : public CompOption::Class {
    public:
        enum Options {
            InitiateButton,
            InitiateKey,
            Opacity,
            KeyMoveInc,
            ConstrainY,
            SnapoffSemimaximized,
            SnapoffDistance,
            SnapbackSemimaximized,
            SnapbackDistance,
            LazyPositioning,
            OptionNum
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        MoveOptions (bool init = true);
        virtual ~MoveOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetInitiateButton ();
        void optionSetInitiateButtonInitiate (CompAction::CallBack init);
        void optionSetInitiateButtonTerminate (CompAction::CallBack term);
        void optionSetInitiateButtonNotify (ChangeNotify notify);

        CompAction & optionGetInitiateKey ();
        void optionSetInitiateKeyInitiate (CompAction::CallBack init);
        void optionSetInitiateKeyTerminate (CompAction::CallBack term);
        void optionSetInitiateKeyNotify (ChangeNotify notify);

        int optionGetOpacity ();
        void optionSetOpacityNotify (ChangeNotify notify);

        int optionGetKeyMoveInc ();
        void optionSetKeyMoveIncNotify (ChangeNotify notify);

        bool optionGetConstrainY ();
        void optionSetConstrainYNotify (ChangeNotify notify);

        bool optionGetSnapoffSemimaximized ();
        void optionSetSnapoffSemimaximizedNotify (ChangeNotify notify);

        int optionGetSnapoffDistance ();
        void optionSetSnapoffDistanceNotify (ChangeNotify notify);

        bool optionGetSnapbackSemimaximized ();
        void optionSetSnapbackSemimaximizedNotify (ChangeNotify notify);

        int optionGetSnapbackDistance ();
        void optionSetSnapbackDistanceNotify (ChangeNotify notify);

        bool optionGetLazyPositioning ();
        void optionSetLazyPositioningNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
MoveOptions::optionGetInitiateButton ()
{
    return mOptions[MoveOptions::InitiateButton].value ().action ();
}

inline void
MoveOptions::optionSetInitiateButtonInitiate (CompAction::CallBack init)
{
    mOptions[MoveOptions::InitiateButton].value ().action ().setInitiate (init);
}

inline void
MoveOptions::optionSetInitiateButtonTerminate (CompAction::CallBack term)
{
    mOptions[MoveOptions::InitiateButton].value ().action ().setTerminate (term);
}

inline void
MoveOptions::optionSetInitiateButtonNotify (MoveOptions::ChangeNotify notify)
{
    mNotify[MoveOptions::InitiateButton] = notify;
}

inline CompAction &
MoveOptions::optionGetInitiateKey ()
{
    return mOptions[MoveOptions::InitiateKey].value ().action ();
}

inline void
MoveOptions::optionSetInitiateKeyInitiate (CompAction::CallBack init)
{
    mOptions[MoveOptions::InitiateKey].value ().action ().setInitiate (init);
}

inline void
MoveOptions::optionSetInitiateKeyTerminate (CompAction::CallBack term)
{
    mOptions[MoveOptions::InitiateKey].value ().action ().setTerminate (term);
}

inline void
MoveOptions::optionSetInitiateKeyNotify (MoveOptions::ChangeNotify notify)
{
    mNotify[MoveOptions::InitiateKey] = notify;
}

inline int
MoveOptions::optionGetOpacity ()
{
    return mOptions[MoveOptions::Opacity].value ().i ();
}

inline void
MoveOptions::optionSetOpacityNotify (MoveOptions::ChangeNotify notify)
{
    mNotify[MoveOptions::Opacity] = notify;
}

inline int
MoveOptions::optionGetKeyMoveInc ()
{
    return mOptions[MoveOptions::KeyMoveInc].value ().i ();
}

inline void
MoveOptions::optionSetKeyMoveIncNotify (MoveOptions::ChangeNotify notify)
{
    mNotify[MoveOptions::KeyMoveInc] = notify;
}

inline bool
MoveOptions::optionGetConstrainY ()
{
    return mOptions[MoveOptions::ConstrainY].value ().b ();
}

inline void
MoveOptions::optionSetConstrainYNotify (MoveOptions::ChangeNotify notify)
{
    mNotify[MoveOptions::ConstrainY] = notify;
}

inline bool
MoveOptions::optionGetSnapoffSemimaximized ()
{
    return mOptions[MoveOptions::SnapoffSemimaximized].value ().b ();
}

inline void
MoveOptions::optionSetSnapoffSemimaximizedNotify (MoveOptions::ChangeNotify notify)
{
    mNotify[MoveOptions::SnapoffSemimaximized] = notify;
}

inline int
MoveOptions::optionGetSnapoffDistance ()
{
    return mOptions[MoveOptions::SnapoffDistance].value ().i ();
}

inline void
MoveOptions::optionSetSnapoffDistanceNotify (MoveOptions::ChangeNotify notify)
{
    mNotify[MoveOptions::SnapoffDistance] = notify;
}

inline bool
MoveOptions::optionGetSnapbackSemimaximized ()
{
    return mOptions[MoveOptions::SnapbackSemimaximized].value ().b ();
}

inline void
MoveOptions::optionSetSnapbackSemimaximizedNotify (MoveOptions::ChangeNotify notify)
{
    mNotify[MoveOptions::SnapbackSemimaximized] = notify;
}

inline int
MoveOptions::optionGetSnapbackDistance ()
{
    return mOptions[MoveOptions::SnapbackDistance].value ().i ();
}

inline void
MoveOptions::optionSetSnapbackDistanceNotify (MoveOptions::ChangeNotify notify)
{
    mNotify[MoveOptions::SnapbackDistance] = notify;
}

inline bool
MoveOptions::optionGetLazyPositioning ()
{
    return mOptions[MoveOptions::LazyPositioning].value ().b ();
}

inline void
MoveOptions::optionSetLazyPositioningNotify (MoveOptions::ChangeNotify notify)
{
    mNotify[MoveOptions::LazyPositioning] = notify;
}



#endif
